'**************************************
'
' C-Control/BASIC       UMETER.BAS
'
' Aufgabe:
'
' - Schrittmotor-Voltmeter
' - Halbschrittbetrieb
' - Gedaempfte Zeigerfuehrung
'
'**************************************
' --- Definitionen --------------------

define Ausgaenge byteport[1]
define EingangA AD[1]
define Bitmuster byte
define Spannung byte
define Position word
define Integral Word

' --- Programmoperationen -------------

Position = 0
Integral = 0

#Loop
  Integral = Integral + EingangA - Position
  if Integral > 255 then gosub Rechts
  if Integral < -255 then gosub Links
goto Loop

#Links
  Integral = Integral + 255
  Position = Position - 1
  looktab  Schritte, (Position and 7), Bitmuster
  Ausgaenge = Bitmuster
return

#Rechts
  Integral = Integral - 255
  Position = Position + 1
  looktab  Schritte, (Position and 7), Bitmuster
  Ausgaenge = Bitmuster
return
end

table Schritte
&B00000001 &B00000011 &B00000010 &B00000110
&B00000100 &B00001100 &B00001000 &B00001001
tabend



